<?php

declare(strict_types=1);

namespace Dedi\SyliusQuotePlugin\Service;

use Dedi\SyliusQuotePlugin\Entity\OrderInterface;
use Symfony\Component\HttpFoundation\Session\SessionInterface;

class QuoteIdSessionManager implements QuoteIdSessionManagerInterface
{
    private readonly string $sessionKeyName;

    private readonly SessionInterface $session;

    public function __construct(string $sessionKeyName, SessionInterface $session)
    {
        $this->sessionKeyName = $sessionKeyName;
        $this->session = $session;
    }

    public function getQuoteIdFromSession(): ?int
    {
        return $this->session->get($this->sessionKeyName);
    }

    public function setQuoteIdInSession(OrderInterface $quote): void
    {
        $this->session->set($this->sessionKeyName, $quote->getId());
    }

    public function removeQuoteIdInSession(): void
    {
        if ($this->session->has($this->sessionKeyName)) {
            $this->session->remove($this->sessionKeyName);
        }
    }
}
